<?php

/*

    Copyright (C) 2005 Free Software Foundation, Inc.

    This file is part of WebDB. Designed and implemented by Zou Jie. Some 
    suggestions could be sent to jzou3700@gmail.com

    WebDB is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    WebDB is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with WebDB; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

include_once( "parse_tag.php" );

class simple_html_parser {
	var $html;
	var $ptr;
	var $content;
	var $o_buf;
	var $searched;

	function simple_html_parser() {
		$this->searched = "table";
		$this->o_buf = null;
	}

	function is_match( &$html, &$ptr, $tag ) {
		$html_cursor = substr( $this->html, $this->ptr, strlen($tag) );
		return strncasecmp($html_cursor, $tag, strlen($tag)) == 0;
	}

	function find_match( &$html, &$ptr, $tag ) {
		for( $i=0; $this->ptr<strlen($this->html); $i++, $this->ptr++ )  {
			if ( $this->is_match($this->html, $this->ptr, $tag) ) {
				return;
			}
		}
	}


	var $syntax = array( "<!",
		array( 	"--",
			null,
			"--"
		) ,
		">"
	);

/*
if ( $begin[0] == "-" && $begin[1] == "-" ) {
echo "\n";
	$html_cursor = substr( $this->html, $this->ptr, 8 );
echo "-----------------------------------------------------\n";
	echo $html_cursor;
echo "\n";
echo "-----------------------------------------------------";
echo "\n\n\n\n";
}
if ( $begin[0] == "-" && $begin[1] == "-" ) { static $c; $c++; }
if ( $begin[0] == "-" && $begin[1] == "-" && $c==2 ) { global 	$debug_switch; $debug_switch=true; } echo $this->ptr."+";
if ( $debug_switch ) { // echo $this->html[$this->ptr]; echo $this->ptr." "; }
*/
	function comment_filter( $rule ) {
		$begin = $rule[0];
		$end = $rule[2];
		if ( $this->is_match( &$this->html, $this->ptr, $begin) ) {
			$this->ptr += strlen( $begin );
			for( ; $this->ptr<strlen($this->html); $this->ptr++ )  {
				if ( 
					$rule[1] &&
					$this->is_match($this->html, $this->ptr, $rule[1][0]) 
				) {
					$this->comment_filter( $rule[1] );
				}
				if ( $this->is_match($this->html, $this->ptr, $end) ) {
					break;
				}
			}
			$this->ptr += strlen($end);
/*
if ( $end == ">" ) {
	echo $this->ptr." ";
	echo substr( $this->html, $this->ptr,100 );
	echo "\n";
}
*/
		}
	}

	function read_tag() {

		for( 
			$this->content = null; $this->ptr<strlen($this->html);
			$this->ptr++ 
		) {
			//
			// filting comments remarked by <!-- -->
			//
			$this->comment_filter( $this->syntax );
/*
echo "_".$this->ptr;
static $mflag;
global $debug_switch; if ( $debug_switch ) { 
	if ( !$mflag ) {
		echo $this->ptr;
		$mflag = true;
	}
}
*/

// echo $this->html[$this->ptr];
/*
			//
			// filting scripts
			//
			$tag_script_begin = "<script";
			$tag_script_end = "</script>";
			while ( $this->is_match( &$this->html, $this->ptr, $tag_script_begin) ) {
				$this->ptr += strlen( $tag_script_begin );
				find_match( &$this->html, &$this->ptr, $tag_script_end );
				$this->ptr += strlen( $tag_script_end );
			}

*/
			if ( $this->html[$this->ptr] == "<" ) {
				$flag = true;
				$this->ptr++;
// echo $this->html[$this->ptr];
			}
			if ( $flag && $this->html[$this->ptr] == ">" ) {
				$flag = false;
				$this->ptr++;
				break;
			}

			if (
				strcmp($this->html[$this->ptr],"\t")!=0 && 
				strcmp($this->html[$this->ptr],"\r")!=0 && 
				strcmp($this->html[$this->ptr],"\n")!=0 
			)
			if ( $flag ) {
				$tag .= $this->html[$this->ptr];
			}
			else {
				$this->content .= $this->html[$this->ptr];
			}
		}

		return $tag;
	}

	//
	// $tag = style ...>
	// $curr_tag = /style
	//
	function tag_match( $tag, $curr_tag ) {
		$name_len = strlen($curr_tag) - 1;
		$curr_tag_name = substr($curr_tag, 1, 1+$name_len );
		$tag_name = substr($tag, 0, $name_len );
		return strncasecmp($curr_tag_name, $tag_name, strlen($tag_name))==0;
	}

	function indent( $t ) {
		$ret = null;
		for( $i=0; $i<$t; $i++ )
			$ret .= " ";

		return $ret;
	}

	function matching_search_tag($tag) {
		return strncasecmp($tag, $this->searched, strlen($searched))==0;
	}

	function is_special_char( $char ) {
		return $char == "<" || $char == ">" || $char == "\n";
	}

	function is_anchor_tag( $tag  ) {
		$j=0;
		while( $this->is_special_char($tag[$j]) ) $j++;
		if ( $tag[$j] == "a" && $tag[$j+1] == " " )
			return true;
		return false;
	}

	function is_table_tags( $tag  ) {
		$table_tags = array( 
			"table", "/table", "tbody", 
			"tr", "td", "/td", "/tr", "/tbody" 
		);
		
		foreach( $table_tags as $item ) {
			for( $i=0, $j=0; $i<strlen($item); $i++ ){
				if ( !is_special_char($item[$i]) ) {
					while( is_special_char($tag[$j]) ) $j++;
					if ( $tag[$j++] != $item[$i] )
						 break;
				}
			}
			if ( $i == strlen($item) )
				return true;
		}
		return false;
	}

	var	$layout;
	var 	$branch;
	var	$id_disp_flag;
	function display($fid, $id, $tag, $level) 
	{
		$output_links = false;


		if ( $fid )
			$full_id = $fid.$id;
		else
			$full_id = $id;

		//
		// Display a branch html tree.
		//
		// $this->branch = $_REQUEST['branch'];

		if ( $this->branch ) {
			$this->id_disp_flag=false;
			if ( strncmp($full_id, $this->branch, strlen($this->branch)) == 0 )
				$this->fmt_print($full_id, $tag, $level);
		}
		//
		// Display anchor only
		//
		else if ( $output_links ) {
			if ( is_anchor_tag($tag) ) {
				$this->o_buf .= $tag."\n";
				$this->fmt_print($full_id, $tag, $level);
			}
		}
		//
		// Display table tag only.
		//
		else if ( $this->layout )  {
			if ( is_table_tags($tag) ) {
				$this->fmt_print($full_id, $tag, $level);
			}
		}
		else {
			$this->fmt_print($full_id, $tag, $level);
		}
	}

	var	$content_disp_flag;
	function fmt_print($full_id, $tag, $level) 
	{

		if ( $this->content && $this->content_disp_flag ) {
			$this->o_buf .= $this->indent( $level );
			$this->o_buf .= "  $this->content\n";
		}

		if ( $this->id_disp_flag ) {
			$this->o_buf .= "<a href=\"?url=".$_REQUEST['url']."&branch=$full_id\">";
			$this->o_buf .= $full_id;
			$this->o_buf .= "</a>";
			$this->o_buf .= "  ";
		}
		else {
			$this->o_buf .= $this->indent( $level );
		}

		if ( $this->branch ) {
				$this->o_buf .= "<$tag>";
	/*
			if ( strncmp($tag, "img", 3)==0 ) {
				global	$server;
				revise_img_tag( "<$tag>", "http://".$server );
				// $this->o_buf .= "$tag";
			}
			else {
				$this->o_buf .= "<$tag>";
			}
	*/
		}
		else
			$this->o_buf .= "$tag";
		$this->o_buf .= "\n";
	}

	function RecursiveLoop($fid, &$id, $tag, &$level) {
global $debug;if ( $debug ) echo "A$level." ;
			$this->display ( $fid, ++$id[$level], "$tag", $level );
			$level++; 
			$id[$level]=0;
			if ( $fid ) 
				$this->html_tree($fid.$id[$level-1].$tag[0].$tag[1]."_");
			else
				$this->html_tree($id[$level-1].$tag[0].$tag[1]."_");
			$level--;
	}

function is_span_tag($tag){
	return strncmp($tag, "SPAN", 4)==0 || strncmp($tag, "/SPAN", 5)==0 ;
}

	function html_tree($fid=null) {
	static	$level=0; 
	static	$curr_tag;
	static  $foward_flag;
	global	$id;

		// some tags without teminate remark. such as <p> <br>
		// These tags still be pushed into the stack. while </table> matched
		// it should be poped up from the stack.
		// 
		if ( $foward_flag ) return;	
		
		$curr_tag = $tag = $this->read_tag();
		if ( $tag == null ) return; // End of the file
		while( $this->is_span_tag($tag) ){
// echo "D$level.";
			$this->display ( $fid, $id[$level], "$curr_tag", $level );
			$curr_tag = $tag = $this->read_tag();
			if ( $tag == null ) return; // End of the file
		} 

		if ( $tag[0] != "/" ) {
			$this->RecursiveLoop($fid, $id, $tag, $level);
			if ( $curr_tag[0] != "/" ) {
				$this->RecursiveLoop($fid, $id, $tag, $level);
			}
			// else if ( $curr_tag[0] == "/" && $this->tag_match($tag, $curr_tag) ) {
			else if ( $this->tag_match($tag, $curr_tag) ) {
global $debug;if ( $debug ) 
echo "B$level." ;
				$this->display ( $fid, $id[$level], "$curr_tag", $level );
				if ( $level == 0 ) return;
				$foward_flag = false;
				$this->html_tree($fid);
			}
			else
				$foward_flag = true;
		}
		else {
			//
			// skip the </SPAN> tag
			//
			if ( strncmp($curr_tag, "/SPAN", 5)==0 ) {
				// $this->html_tree($fid);
global $debug;if ( $debug ) 
echo "S$level." ;
				$this->display ( $fid, $id[$level], "$curr_tag", $level );
				$curr_tag = $tag = $this->read_tag();
				if ( $tag == null ) return; // End of the file
			}
		}

		if ( $fid==null ) {
			if ( $curr_tag )
				$this->o_buf .= "$curr_tag";
		}
	}

	function html_process( $content, $brnch=null ) 
	{
	global $id;

		$this->branch = $brnch;
		$this->html = $content;

		if ( $brnch ) 
			$this->id_disp_flag=false;
		else
			$this->id_disp_flag=true;
		$this->content_disp_flag=false;
		$this->content_disp_flag=true;
		$this->layout=false;

		$this->ptr = 0; $id[0]=0;
		$this->html_tree();


		return $this->o_buf;
	}
}

?>

