<?php
/*

    Copyright (C) 2005 Free Software Foundation, Inc.

    This file is part of WebDB. Designed and implemented by Zou Jie. Some 
    suggestions could be sent to jzou3700@gmail.com

    WebDB is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    WebDB is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with WebDB; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

include_once( "parse_tag.php" );
include_once( "poc_req_def.php" );
include_once( "theme.php" );

function get_select_html( $name, $var_def, $default_value ) {
	$ret_val = "<select name=\"$name\">";
	foreach( $var_def as $key => $value ) {
		if ( strcmp($default_value, $key)==0 )
			$selected = "selected";
		else
			$selected = null;

		if ( $value )
			$ret_val .= "<option $selected value=\"$key\">$value</option>";
		else
			$ret_val .= "<option $selected value=\"$key\">$key</option>";
	}
	return $ret_val .= "</select>";
}

function get_inputfield_html( $name, $default_value ) {
	return "<input name=\"$name\" value=\"$default_value\">";
}

function get_checkbox_html( $name, $default_value ) {
	if ( $default_value )
		return "<input name=\"\$name\" type=\"checkbox\" checked>";
	else
		return "<input name=\"\$name\" type=\"checkbox\">";
}

function get_textarea_html( $name, $default_value ) {
	return <<<EOF
		<textarea name="$name" rows="2" cols="40">
$default_value
		</textarea>
EOF;
}

function get_blank_html( $name ) {
	return  "<input name=\"$name\" type=\"hidden\"><img src=\"/images/a.gif\">";
}

function putFieldDataHtml( &$value_arr, $path, $level=2 ) {
static $pr_field;
		if ( $level == 2 ) {
			$pr_field = new parser( $path, "/" ); 					
		}
// echo "<pre>";
// print_r( $pr_field->tag_tree );
		if ( $level < count($pr_field->tag_tree) ) {
			$index = $pr_field->tag_tree["/.$level"][0]; 
			return putFieldDataHtml( &$value_arr[$index], $path, $level+1  );
		}
		else if ( $level == count($pr_field->tag_tree) ) {
			$index = $pr_field->tag_tree["/.0"][0]; 
			return "<font color=\"blue\">".$value_arr[$index]."</font>";
		}
// echo "</pre>";
}

function def_input_html( $path ) {
global $poc_requests;
	$name = urlencode( $path );
	$rec_no = get_record_no();
	$def_value = getArray( $poc_requests[$rec_no], $path ); 
	return $retval = "<input name=\"$name\" value=\"$def_value\">";
}

function indent( $n ) {
        for( $i=0; $i < $n; $i++ )
                echo "\t";
}

function toString( &$arr, $level=0 ) {
static $watermark;

	$watermark = $level ;

	// if ( is_array($arr) )
	foreach( $arr as $key => $value ) {
		if ( $key[0] == '.' ) continue;
		if ( is_array($value) ) {
			$temp = toString( $value, $level+1 );
			if ( $temp ) {
				$flags = repeat( $watermark - $level, ">" );
				$ret_val .= "$key $flags $temp ";
			}
		}
		else
			if ( $value ) $ret_val .= "$key:<font color=\"blue\">$value</font>  ";
	}
	return $ret_val;
}

$abbr['Support Expertise Needed from Sun'] = "Support Expertise";
function list_html( $arr, $level=0 ) {
global $abbr;
	if ( !is_array($arr) ) return ;

	if ( $level > 1 ) {
		return toString( $arr );
	}

	echo "<table border=\"0\">";
	foreach( $arr as $key => $item ) { 
	// for( $key=count($arr)-1; $key>=0; $key-- ) {
		$item = $arr[$key]; 
		if ( !$item ) continue;
		if ( $key[0] == '.' ) continue;
		echo indent($level); echo "<tr><td>";
		if ( is_array($item) ) {
			$level++ ; 
			$edit_icon = "<img border=\"0\" src=\"/image/pencil.jpeg\">";
			echo "<center><a href=\"?modify=$key\">$edit_icon<br></a></center>";
			echo "<center><a href=\"?dump=$key\">$key</a></center>";
			echo "</td><td>\n";

			$columns = null;
			$col_num = 0;
			foreach( $item as $kkey => $iitem ) {
				if ( $key[0] == '.' ) continue;
				if ( is_array($iitem) ) {
					$temp = list_html( $iitem, $level+1 );
					if ( $temp ) {
						$columns .= indent($level);
						$columns .= "<table border=\"0\" width=\"100%\">"; 
						$columns .=  "<tr><td bgcolor=\"lightblue\">";
						$columns .= $abbr[$kkey] ? $abbr[$kkey] : $kkey;
						$columns .= "</td></tr><tr><td>";
						$columns .= $temp;
						$columns .= "</td></tr>"; 
						$columns .= "</table>\n";

						if ( ++$col_num == 4 ) break;
						$columns .= "</td><td width=\"25%\" valign=\"top\">";
					}
				}
			}
			for( $col_num++;$col_num < 4; $col_num++ )
				$columns .= "</td><td width=\"25%\">";

			echo "<table border=\"0\" class=hline width=\"100%\">";
			$cs = $col_num;
			echo indent($level); echo "<tr><td colspan=\"$cs\">";
			foreach( $item as $kkey => $iitem ) {
				if ( $key[0] == '.' ) continue;
				if ( !is_array($iitem) ) {
					$temp = rtrim($iitem);
					if ( $temp ) 
						// echo "<font color=\"white\">$kkey</font>:<font color=\"blue\">$iitem</font>  ";
						echo "$kkey:<font color=\"blue\">$iitem</font>  ";
				}
			}
			echo "</td></tr>\n"; 
			echo "<tr valign=\"top\"><td width=\"25%\" valign=\"top\">";
			echo $columns;
			echo "</td></tr></table>";
		}
		else {
			$edit_icon = "<img src=\"/image/pencil.jpeg\">";
			echo "<a href=\"?modify=$key\">$edit_icon $key</a>";
			echo "</td><td>";
			echo "$item";
		}
		echo "</td></tr>";
	}
	echo "</table>";
	echo "\n";
}

function repeat( $num, $str ) {
	for( $i=0; $i<$num; $i++ ) $ret_str .= $str;
	return $ret_str;
}

function table_lines( $arr, $path="/", $level=1 ) {
static $lines=0;
	if ( !is_array($arr) ) return;
	foreach( $arr as $key => $item ) { 
		if ( $key[0] == '.' ) continue;
		if ( is_array($arr) ) {
			$lines++;
			table_lines( $item, "$path/$key", $level+1);
		}
		else {
			$lines++;
		}
	}
	return $lines;
}

function to_urlencode_string( $arr, $path, $level=1) {
	if ( !is_array($arr) ) 
		return $ret_val = urlencode("$path")."=".urlencode("$arr");

	foreach( $arr as $key => $item ) {
		if ( $key[0]=="." ) continue;
		if ( is_array($item) ) {
			$ret_val .= to_urlencode_string( $item, "$path/$key", $level+1 );
		}
		else {
			$ret_val .= urlencode("$path/$key")."=".urlencode("$item")."&";
		}
	}

	return $ret_val;
}

$modify=true;
// $value_arr=null;
function form_html( $arr, $path, $level=1, $l2=0 ) {
static  $lines=0;
static  $num_mid_line;
static  $first_column_displayed=false;
static  $arr_root;
global	$modify;
global	$value_arr;
global  $poc_requests;

	if ( !is_array($arr) ) return ;

	if ( $level== 1 ) {
		$arr_root = $arr;
		$total_lines = table_lines($arr);
		$num_mid_line = $total_lines / 2; 
	}

	$ret_val = indent($level); 
	$ret_val .= "<table border=\"0\" cellpadding=\"0\" cellspacing=\"0\" width=\"100%\"> <!-- table \"$path\" begin -->\n";
	foreach( $arr as $key => $item ) { 
		if ( $key[0] == '.' ) continue;
		$ret_val .= indent($level)."<tr><td>\n";

		preg_match( "/\.(\d+)/", $key, $matches );
		if ( $matches[1] ) {
			$newkey = preg_replace( "/\.(\d+)/is", ".2", $key ); 
			// $copy_urlstring = to_urlencode_string( $item, "$path/$newkey" );
			$copy_urlstring = "";
// echo $copy_urlstring;
			$key_attr = "<a href=\"?$copy_urlstring\"><img border=\"0\" src=\"/image/copy.jpeg\"></a>";
		}
		else
			$key_attr = null;


		if ( is_array($item) ) {
			$lines++;
			$ret_val .= indent($level); $ret_val .= "<table class=array align=\"justfy\" border=\"0\" cellpadding=\"0\" cellspacing=\"0\" width=\"100%\">\n";
			$ret_val .= indent($level); $ret_val .= "<tr>";
			$cs = $level+1;
			$ret_val .= "<td bgcolor=\"#385b74\" colspan=\"$cs\">";
			$ret_val .= "<font color=\"yellow\">";

			$ret_val .= "$key $key_attr";
			$ret_val .= "</font>";
			$ret_val .= "</td>\n";
			$ret_val .= indent($level); $ret_val .= "</tr>\n";

			$ret_val .= indent($level); $ret_val .= "<tr>";
			// $ret_val .= repeat( $level, "<td width=\"1%\">.</td>" );
			$ret_val .= repeat( 1, "<td width=\"1%\"><img src=\"/images/a.gif\"></td>" );
			$ret_val .= "<td>\n";
			$ret_val .= form_html( $item, "$path/$key", $level+1, $l2+1 );
			$ret_val .= indent($level); $ret_val .= "</td></tr>\n";
			$ret_val .= indent($level); $ret_val .= "</table>\n";

			$ret_val .= indent($level); $ret_val .= "<table><tr><td></td></tr></table> ";
			$ret_val .= "<!-- Blank line -->\n";
		}
		else {
			if ( $modify ) {
global $var_type_def;
global $data_def;

				$field = null;
				$rules = getArray( $data_def, "$path/$key" );
				if ( $rules[0] == '*' ) {
					$temp = substr($rules, 1, strlen($rules)-1);
					$field = $rules[0];
				}
				else
					$temp = $rules;

				$lt_rules = ltrim( $temp );
				$name = urlencode( "$path/$key" );
				$default_value = $item;

				if ( strcmp($lt_rules, "select")==0 ) {
					$field .= get_select_html( $name, $var_type_def[$key], $default_value );
				}
				else if ( strcmp($lt_rules, "checkbox")==0 ) {
					$field .= get_checkbox_html( $name, $default_value );
				}
				else if ( strcmp($lt_rules, "textarea")==0 ) {
					$field .= get_textarea_html( $name, $default_value );
				}
				else if ( strcmp($lt_rules, "blank")==0 ) {
					$field .= get_blank_html( $name );
				}
				else {
					$field .= get_inputfield_html( $name, $default_value );
				}
			}
			else {
				$field = putFieldDataHtml( $arr_root, "$path/$key" );
			}


			$output = null;
			if ( $lines > $num_mid_line & !$first_column_displayed ) {
$output .=  "<!-- Sperate columns begin -->\n";
				$tlevel= $level+$l2;
				for( $i=0; $i<$tlevel; $i++ ) {
					$output .= indent($tlevel-$i)."</td></tr>\n";
					$output .= indent($tlevel-$i)."</table>\n";
				}
$output .=  "</td>\n<td>...</td>\n<td valign=\"top\">\n";
				for( $i=1; $i<=$tlevel; $i++ ) {

					if ( $i % 2 ) 
						$output .= indent($i)."<table border=\"0\" cellpadding=\"0\" cellspacing=\"0\" width=\"100%\">\n";
					else
						$output .= indent($i)."<table class=\"array\" border=\"0\" cellpadding=\"2\" cellspacing=\"0\" width=\"100%\">\n";
					$output .= indent($i)."<tr><td>\n";
				}
				$first_column_displayed = true;
$output .=  "<!-- Sperate columns end -->\n";
			}

			$output .=  indent($level)."<table><tr><td><font color=\"black\">$key $key_attr</font></td><td>\n";
			$output .=  "$field\n";
			$output .=  indent($level)."</td></tr></table>\n";

			$ret_val .= $output;
			$lines++;
		}
		$ret_val .= indent($level)."</td></tr>\n";
	}
	$ret_val .= indent($level)."</table> <!-- table \"$path\" end -->\n";

	return $ret_val;
}

function fillArray( &$arr, $tag_tree, $value, $level=2 ) {
	if ( $level == count($tag_tree) ) {
		$key = $tag_tree["/.0"][0];
		$arr[ $key ]  = $value;
		return;
	}
	else  {
		
		$key = $tag_tree["/.$level"][0];
		$node = &$arr[ $key ] ;

		if ( is_array($node) ) {
			fillArray( &$node, $tag_tree, $value, $level + 1 );
		}
		else {
			$node  = array();
			fillArray( &$node, $tag_tree, $value, $level + 1 );
		}
	}
}

//
// under construction!
//
function validate( $request, $data_def, $path="POC Request", $level=0 ) {
	if ( $level==0 ) reset( $data_def );
	// $ret_val = "No validation rules";
	foreach( $request as $req_key => $req_item ) {
		$data_def_item = getArray( $data_def, "$path/$req_key" );
		
		if ( is_array($req_item) ) {
			$ret_val = validate( $req_item, $data_def, "$path/$req_key", $level+1 );
			$test_str = "We must have";
			if ( strncasecmp( $ret_val, $test_str, strlen($test_str)) == 0 )
				return $ret_val;
			if ( is_array($data_def_item) ) {
				if ( array_key_exists('.*', $data_def_item) ) {
					if (  toString($req_item)!=null )
						$ret_val = '*';
					else {
						return "We must have $path/$req_key information 1";
					}
				}
				else {
				 	// $ret_val = '-';
				}
			}
			// $ret_val = '-';
		}
		else {
			if ( $data_def_item[0] == '*' ) {
				if ( $req_item != null ) 
					$ret_val = '*';
				else
					return "We must have $path/$req_key information 2";
			}
			else {
				// $ret_val = '-';
			}
		}
			
	}
	return $ret_val;
}

//
// The function setArray is not debuged.
// 

/* ------------------ deleted --------------------------
function setArray( &$arr, $path, $value, $level=2 ) {
static 	$tag_tree;

	if ( $level == 2 ) {
		$u = new parser( $path, "/" );	
		$tag_tree = $u->tag_tree;
	}
	if ( $level == count($tag_tree) ) {
		$key = $tag_tree["/.0"][0];
		$arr[$key] = $value; 
	}
	else {
		$key = $tag_tree["/.$level"][0];
		if ( is_array($node) ) {
			setArray( $arr[$key], $path, $value, $level+1 );
		}
		else {
			$node  = array();
			setArray( &$node, $tag_tree, $value, $level + 1 );
		}
	}
}
 ------------------ deleted -------------------------- */

function getArray( &$arr, $path, $level=2 ) {
static 	$tag_tree;

	if ( $level == 2 ) {
		$u = new parser( $path, "/" );	
		$tag_tree = $u->tag_tree;
	}
	if ( $level == count($tag_tree) ) {
		$key = $tag_tree["/.0"][0];
		return $arr[$key]; 
	}
	else {
		$key = $tag_tree["/.$level"][0];
		return $ret_val = getArray( $arr[$key], $path, $level+1 );
	}
}

function get_data( &$db, $arr ) {
	foreach( $arr as $key => $value ) {
		$ukey = urldecode( $key );

		$pr_field = new parser( $ukey, "/" ); 		// print_r( $pr_field->tag_tree );
		if ( strcmp($pr_field->tag_tree["/.1"][0], "POC Request")==0 )
			fillArray( &$db, $pr_field->tag_tree, $value );
	}
// if ( $debug ) { print_r( $ret_val ); }
}


function save_array( $arr, $filename ) {
        $s = serialize($arr);
        clearstatcache();
        $fp = fopen( $filename, "w" ); fputs( $fp, $s ); fclose( $fp );
}

function restore_array( &$arr, $filename ) {
        clearstatcache();
	//
        /* while ( ($f = file($database_dir."/tree.dat")) == null ) echo "sleep\n"; */
	//
        $f = file( $filename );
        $s = implode( "", $f );
        $arr = unserialize($s);
}

function get_navigation_bar( $rec_no ) {
	$ret_val =  "<table><tr><td>";
	$ret_val .=  "<a href=\"?list\"><img border=\"0\" src=\"/images/list_not_pressed_active.gif\"></a>";
	$ret_val .= "</td><td>";
	if ( !array_key_exists( 'inputform', $_REQUEST) ) 
		$ret_val .= "<a href=\"?modify=$rec_no\"><img border=\"0\" src=\"/images/modify_not_pressed_active.gif\"></a>";
		
	$ret_val .= "</td></tr></table>";
	return $ret_val;
}

function display_field_data( &$request, $rec_no ) {
global $modify;
global $value_arr; 
global $data_def;

	echo "<table border=\"0\" align=\"top\" cellpadding=\"0\" cellspacing=\"0\" width=\"100%\"> <!-- Column Frame begin -->\n";
	echo "<tr><td>\n";

	$modify = false;
// $value_arr = $request; 
	echo form_html( $request, "POC Request" );

	echo "</td></tr></table> <!-- Column Frame end -->";
	echo get_navigation_bar( $rec_no );
}

function display_input_field( $rec_no ) {
global	$modify;
global	$data_def;
global	$poc_requests;

	echo "<form enctype=\"multipart/form-data\" action=\"poc_request.php\" method=\"post\">";
	// echo "<input type=\"submit\" class=\"buttonblue\">\n";
	echo "<table border=\"0\" align=\"top\" cellpadding=\"0\" cellspacing=\"0\" width=\"100%\"> <!-- Column Frame Begin -->\n";
	echo "<tr><td>\n";
	if ( $rec_no == -1 ) { 
		$modify = true;
		echo form_html( $data_def, "POC Request" );
		echo "<input name=\"modify\" value=\"-1\" type=\"hidden\">\n";
		echo "<input name=\"init\" type=\"hidden\">\n";
	}
	else {
		$modify = true;
		echo form_html( $poc_requests[$rec_no], "POC Request" );
	}
	echo "</td></tr></table> <!-- Column Frame End -->\n";
/* ******************************************************************************************
	if ( $rec_no == -1 ) 
		echo "<input name=\"append\" type=\"hidden\">\n";
	else {
		echo "<input name=\"update\" type=\"hidden\">\n";
		// echo "<input name=\"modify\" value=\"$rec_no\" type=\"hidden\">\n";
	}
 ****************************************************************************************** */
	echo "<input name=\"update\" type=\"hidden\">\n";

	echo "<input type=\"submit\" class=\"buttonblue\">\n";
	echo "</form>\n";
	echo get_navigation_bar( $rec_no );
}

function get_record_no() {
	$ret_val = $_REQUEST['recno'];
	if ( $_REQUEST['modify'] != null )
		$ret_val = $_REQUEST['modify'];

	return $ret_val;
}

/*
When adding an element to an array, it may be interesting to know with which key it was added. Just adding an element does not change the current position in the array, so calling key() won't return the correct key value; you must first position at end() of the array:
*/

function append( &$arr, $key, $item ) {
	$rec_no = "<$key>".time();
	$arr[ $rec_no ] = $item;
	end($arr); 				// important!
	return $rec_no = key( $arr );
}

//
// let $array_a = $array_b;
//
function update_array_recursive( &$array_a, &$array_b, $level=1 ) { 
	
}

function update( &$poc_requests, $rec_no, $request ) {
	$poc_requests[$rec_no] = $request;
}

// 
// remove temple record which was generated by inputform
//
function remove_temp_record( &$poc_requests, $rec_no ) {
	preg_match( "/<(.*)>(.*)/", $rec_no, $matches );
	if ( $matches[1] != null ) {
		$temp_rec = "<>{$matches[2]}";
		if ( $poc_requests[$temp_rec] != null ) {
			unset( $poc_requests[$temp_rec] );
			// echo "Temple record have been removed";
		}
	}
}

function disp_list_html( $poc_requests ) {
        echo getPageHead( count($poc_requests) );
	$rev_poc_req = array_reverse( $poc_requests );
	list_html( $rev_poc_req );
}

function disp_err_msg( $errmsg ) {
	$rec_no = get_record_no();
	// echo "<font color=\"red\">$errmsg, rec_no = $rec_no</font>";
	echo "<font color=\"red\">$errmsg</font>";
}

function init() {
global $data_def;
global $poc_requests;

	$rec_no = 0;
	setcookie("recno", $rec_no, time() + 3600*24*7);
	get_data( $poc_requests[$rec_no], $_REQUEST );
	$request = $poc_requests[$rec_no];

	echo getPageHead( "Initial Template, " );
	if ( is_array($request) ) {
		$errmsg = validate( $request, $data_def );
		if ( strcmp($errmsg,"*")==0 ) {
			display_field_data( $poc_requests[$rec_no], $rec_no );
			save_array( $poc_requests, "poc_requests.dat" );
		}
		else {
			disp_err_msg( $errmsg );
			display_input_field( $rec_no );
		}
	}
	else {
		display_input_field( -1 );
	}
}

//
// Action 
//
/*
	list
	new request
	modify
	inputform
	init
	delete
*/

restore_array( $poc_requests, "poc_requests.dat" );

if ( $poc_requests[0] == null ) {
	init();
}
else {

	if ( array_key_exists('init', $_REQUEST) ) {
		init();
	}
	else if ( array_key_exists('list', $_REQUEST) ) {
		disp_list_html( $poc_requests );
	}
	else if ( array_key_exists('inputform', $_REQUEST) ) {
		$rec_no = append( $poc_requests, $request['Requester'], $request );
		setcookie("recno", $rec_no, time() + 3600*24*7);
		// setcookie("newrecord", "true", time() + 30);
		echo getPageHead( $rec_no );
		display_input_field( 0 );

	/* ---------------------------------------------------------------------------
	// update( $poc_requests, $rec_no, $request );
	// $request = get_data( $poc_requests[$rec_no], $_REQUEST );
		if ( strcmp($errmsg,"*")==0 && !$request ) {
			update( $poc_requests, $rec_no, $request );
	// $request = get_data( $poc_requests[$rec_no], $_REQUEST );
			display_field_data( $request, $rec_no );
			save_array( $poc_requests, "poc_requests.dat" );
		}
		else {
			disp_err_msg( $errmsg );
			update( $poc_requests, $rec_no, $request );
	// $request = get_data( $poc_requests[$rec_no], $_REQUEST );
			display_input_field( 0 );
		}
	 -------------------------------------------------------------------------------- */
	}
	else  if ( array_key_exists('update', $_REQUEST) ) {
		$rec_no = get_record_no();
		get_data( $poc_requests[$rec_no], $_REQUEST );

		$request = $poc_requests[$rec_no];
		preg_match( "/<(.*)>(.*)/", $rec_no, $matches );
		if ( $matches[1] == null ) {
			$temp_rec_no = $rec_no;
			$rec_no = "<{$request['Requester']}>{$matches[2]}";
			$poc_requests[$rec_no] = &$poc_requests[$temp_rec_no];
			remove_temp_record( $poc_requests, $rec_no );
		}

		echo getPageHead( $rec_no );
		$errmsg = validate( $poc_requests[$rec_no], $data_def );
		if ( strcmp($errmsg,"*")==0 ) {
			display_field_data( $poc_requests[$rec_no], $rec_no );
			save_array( $poc_requests, "poc_requests.dat" );
		}
		else {
			disp_err_msg( $errmsg );
			display_input_field( $rec_no );
		}
	}
	else if ( array_key_exists('modify', $_REQUEST) ) {
		$rec_no = get_record_no();
		setcookie("recno", $rec_no, time() + 3600*24*7);
		echo getPageHead( $rec_no );
		display_input_field( $rec_no );
	}
	else if ( $del_rec_no = $_REQUEST['delete'] ) {
		unset( $poc_requests[$del_rec_no] );
		save_array( $poc_requests, "poc_requests.dat" );
		disp_list_html( $poc_requests );
	}
	/* ***************************************************************************
	else if ( array_key_exists('append', $_REQUEST) ) {
		$rec_no = append( $poc_requests, $request['Requester'], $request );
		setcookie("recno", $rec_no, time() + 3600*24*7);
		echo getPageHead( $rec_no );
		disp_err_msg( $errmsg );
		if ( strcmp($errmsg,"*")==0 ) {
			display_field_data( $request, $rec_no );
		}
		else {
			display_input_field( $rec_no );
		}
		save_array( $poc_requests, "poc_requests.dat" );
	}
	****************************************************************************** */
	else if ( array_key_exists('dump', $_REQUEST) ) {
		$rec_no = $_REQUEST['dump'];
		echo getPageHead( $rec_no );
		display_field_data( $poc_requests[$rec_no], $rec_no );
	}
	else {
		if ( $_REQUEST ) {
			update( $poc_requests, $rec_no, $request );
			display_input_field( $rec_no );
		}
		else 
			disp_list_html( $poc_requests );
	}
}
echo $pagefoot;

?>
</body>
</html>
